#!/usr/bin/python3
import uuid
import subprocess
import sys, os
import cgi
import cgitb, jinja2, urllib.request
import re
from pathlib import Path

cgitb.enable()
print("Content-Type: text/html\n\n")
HTML = '''<!DOCTYPE html>
<html><head>
<meta charset="UTF-8">
<title>Modern Menu</title>
<style>
  #menu {
    background-color: #bdf5fc;
    width: 200px; /* Adjust width as needed */
    padding: 20px;
    box-sizing: border-box;
  }

  #menu b {
    font-size: 24px; /* Larger font size for the menu title */
    color: #333; /* Darker color for better readability */
    margin-bottom: 20px; /* Space below the menu title */
    display: inline-block; /* To enable margin to work */
  }

  #menu a {
    display: block; /* Make each link take its own line */
    color: #007bff; /* A more vibrant link color */
    text-decoration: none; /* Remove underline */
    margin: 10px 0; /* Space between links */
    padding: 8px; /* Padding inside links for larger click area */
    border-radius: 5px; /* Rounded corners for links */
    transition: background-color 0.3s, color 0.3s; /* Smooth transition for hover effects */
  }

  #menu a:hover {
    background-color: #007bff; /* Background color on hover */
    color: #ffffff; /* Text color on hover */
  }

  /* Additional style to remove link spacing and align to the left */
  body {
    margin: 0;
    font-family: Arial, sans-serif; /* Modern font */
  }
</style>
<title></title>
</head>

<body>
  <div id="header" style="background-color:#00c062;text-align:center">
    <h1 style="margin-bottom:0;">Gruppe 7</h1>
  </div>

  <div id="menu" style="background-color:#bdf5fc; height:100%;float:left;padding: 10px;">
    <b>Menu</b><br>
    <a href="main.py">Main page</a><br>
    <br>
    <a href="cgiInput.py">Calculating GC Content</a><br>
    <br>
    <a href="GOR.py">Protein Secondary Structure Prediction</a><br>
    <br>
    <a href="cv.html">GOR validation report</a><br>
    <br>
    <a href="dna2protein.py">DNA2Protein</a><br>    
    <br>
    <a href="callAlignment.py">Alignment</a><br>
    <br>
    <a href="callValidation.py">Alignment Validation</a><br>
    <br>
    <a href="Correlations_Benchmarking_1.pdf">Alignment correlation and benchmarking</a><br>

  </div>
  <div id="introduction" style="background-color:#6affda; height:30%" <pre=""><br>
       Here you can train a model for GOR-prediction algorithms. <br>
       Alternatively, you can use our models, trained on a random PDB dataset with ~5000 sequences. <br>      

  </div>
  <br>
    <a href="GOR1-4.py">Protein Secondary Structure Prediction for single sequences</a><br>
    <br>
    <a href="GOR5.py">Protein Secondary Structure Prediction using multiple alignment files</a><br><br><br>

    <br><h2 style="margin-bottom:0;">Model training:</h2><br><div id="input info" style="background-color:#fc9a00">
  <h3>Input and Output: </h3>
  <p> Input: protein sequences in FASTA format or PDB ids separated by comma.<br>
  Output: A model trained on provided/parsed protein sequences for a chosen GOR algorithm.<br>
  </p>  
  </div><br><br><br>
    {% if result  %}
   
    <p>PDB IDs provided: {{ pdbids }}</p>
    <br>
    <a href="{{ result }}" download>Download Model</a>

{% else %}
<h3>Please choose one form of training data input: </h3>
   <br><script>
function toggleInput() {
    var selection = document.getElementById("inputType").value;
    if (selection == "sequence") {
        document.getElementById("sequenceInput").style.display = "";
        document.getElementById("pdbidInput").style.display = "none";
    } else if (selection == "pdbid") {
        document.getElementById("sequenceInput").style.display = "none";
        document.getElementById("pdbidInput").style.display = "";
    }
}
window.onload = toggleInput; // Ensure correct input is shown on load
</script>

<form action="GOR.py" method="post" enctype="multipart/form-data" title="PDB ID and Protein Sequence">
    <select id="inputType" onchange="toggleInput()">
        <option value="sequence" selected>Sequence</option>
        <option value="pdbid">PDB ID</option>
    </select><br><br>

    <div id="sequenceInput">
        <label for="sequence">Sequence:</label>
        <textarea name="sequence" id="sequence" rows="5"></textarea><br><br>
    </div>

    <div id="pdbidInput" style="display:none;">
        <label for="pdbid">PDB IDs, separated by comma:</label>
        <input type="text" name="pdbid" id="pdbid"><br><br><br>
    </div><br><br>
    <label for="method">Specify GOR Algorithm:</label>
    <select name="method" id="method">
    <option value="">Select a method...</option>
        <option value="GOR1">GOR1</option>
        <option value="GOR3">GOR3</option>
        <option value="GOR4">GOR4</option>
    </select><br><br>

    <input type="submit" value="Submit">

    

</form>



{% endif %}

    
    </body></html>'''

form = cgi.FieldStorage()
UPLOAD_DIR = 'uploads'

pdbids = form.getvalue('pdbid', '').strip()
sequence = form.getvalue('sequence', '').strip()
x = '' 
pdbid_values = ''
if "method" in form and form.getvalue("method"):
  if pdbids and not sequence:
      pdbid_values = form.getfirst('pdbid')
      outname = "pdb_seqs.txt"
      pre_outname = "pdb_list.txt"
      
      outFilePath1 = os.path.join(UPLOAD_DIR, outname)
      outFilePath2 = os.path.join(UPLOAD_DIR, pre_outname)

      outFile2 = open(outFilePath2, "w")
      outFile2.write(pdbid_values)
      outFile2.close()
      
      selected_method = form.getvalue('method')

        
      # GOR1
      if selected_method == "GOR1":
          x = f'uploads/gor1_model_{uuid.uuid4()}.txt'
          subprocess.run(['python3', 'seclib_reader.py', '--pdb-id', outFilePath2, '--output', outFilePath1], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
          subprocess.run(['java', '-jar', 'train.jar', '-db', outFilePath1, '-method', 'gor1', '--model', x], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
              
      # GOR3
      elif selected_method == "GOR3":
          x = f'uploads/gor3_model_{uuid.uuid4()}.txt'
          subprocess.run(['python3', 'seclib_reader.py', '--pdb-id', outFilePath2, '--output', outFilePath1], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
          subprocess.run(['java', '-jar', 'train.jar', '-db', outFilePath1, '-method', 'gor3', '--model', x], stdout=subprocess.PIPE, stderr=subprocess.PIPE)

      # GOR4
      elif selected_method == "GOR4":
          x = f'uploads/gor4_model_{uuid.uuid4()}.txt'
          subprocess.run(['python3', 'seclib_reader.py', '--pdb-id', outFilePath2, '--output', outFilePath1], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
          subprocess.run(['java', '-jar', 'train.jar', '-db', outFilePath1, '-method', 'gor4', '--model', x], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
      

      


  elif sequence and not pdbids:
      outname = "train_seqs.txt"
      outFilePath1 = os.path.join(UPLOAD_DIR, outname)
      outFile1 = open(outFilePath1, "w")
      outFile1.write(sequence)
      outFile1.close()
      selected_method = form.getvalue('method')

        
      # GOR1
      if selected_method == "GOR1":
          x = f'uploads/gor1_model_{uuid.uuid4()}.txt'
          subprocess.run(['java', '-jar', 'train.jar', '-db', outFilePath1, '-method', 'gor1', '--model', x], stdout=subprocess.PIPE, stderr=subprocess.PIPE)
              
      # GOR3
      elif selected_method == "GOR3":
          x = f'uploads/gor3_model_{uuid.uuid4()}.txt'
          subprocess.run(['java', '-jar', 'train.jar', '-db', outFilePath1, '-method', 'gor3', '--model', x], stdout=subprocess.PIPE, stderr=subprocess.PIPE)

      # GOR4
      elif selected_method == "GOR4":
          x = f'uploads/gor4_model_{uuid.uuid4()}.txt'
          subprocess.run(['java', '-jar', 'train.jar', '-db', outFilePath1, '-method', 'gor4', '--model', x], stdout=subprocess.PIPE, stderr=subprocess.PIPE)



headers = {'User-Agent': 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:23.0) Gecko/20100101 Firefox/23.0'}
print(jinja2.Environment().from_string(HTML).render(result = x, pdbids = pdbid_values))






